/*
 * Treebird - Lightweight frontend for Pleroma
 * Copyright (C) 2022 Nekobit
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef LOCAL_CONFIG_SET_H
#define LOCAL_CONFIG_SET_H
#include <mastodont.h>
#include "local_config.h"
#include "session.h"
#include "attachments.h"
#include "key.h"

int set_config_str(struct session* ssn,
                   char** v,
                   char* cookie_name,
                   struct key* post,
                   struct key* cookie);

int set_config_int(struct session* ssn,
                   int* v,
                   char* cookie_name,
                   struct key* post,
                   struct key* cookie);

void load_config(struct session* ssn, mastodont_t* api);

#endif // LOCAL_CONFIG_SET_H
